! -*- F90 -*-
 BEGIN_PROVIDER [integer, nshl]
&BEGIN_PROVIDER [integer, nprimt]
BEGIN_DOC
! number of shells with decomposed sp functions 
! number of primitives with decomposed sp functions 
END_DOC
       implicit none
       integer :: i,nsp

       nsp=0
       nshl=0
       nprimt=0
       do i=1,nshl_r
        if (il_r(i).eq.-1) then
         nshl+=2
         nsp+=1
         nprimt+=2*nprim_r(i)
        else
         nshl+=1
         nprimt+=nprim_r(i)
        end if
       end do

       if (writeinfo) then
        write(6,*)
        write(6,*) ' nshl and nprimt after sp decomposition: ',nshl,nprimt
        write(6,*) ' found ',nsp,' sp shells in the basis set '
        write(6,*)
       end if

END_PROVIDER

 BEGIN_PROVIDER [integer, nprim, (nshl)]
&BEGIN_PROVIDER [integer, il, (nshl)]
&BEGIN_PROVIDER [integer, nshlat, (natom)]
&BEGIN_PROVIDER [integer, icent, (nshl)]
&BEGIN_PROVIDER [real*8, exx, (nprimt) ]
&BEGIN_PROVIDER [real*8, coeff, (nprimt) ]
BEGIN_DOC
! decompose sp functions for the arrays nprim, il, icent
! the same for the exponents and coefficients of the primitives 
END_DOC
      implicit none
      integer :: i,ii,iii,j,iprim,iiprim

      do i=1,nshl
       nprim(i)=0
       il(i)=0
       icent(i)=0
      end do
      do i=1,natom
       nshlat(i)=0
      end do

      ii=0
      iiprim=0
      iprim=0
      do i=1,nshl_r
! arrays il, nprim, icent
       if (il_r(i).eq.-1) then
! the s functions
        ii=ii+1
        il(ii)=0
        nprim(ii)=nprim_r(i)
        icent(ii)=icent_r(i)
! we have a s and a p shell
        nshlat(icent_r(i))+=2
        do j=1,nprim_r(i)
         coeff(iiprim+j)=coeff_r(iprim+j)
         exx  (iiprim+j)=exx_r  (iprim+j)
        end do
        iiprim+=nprim_r(i)

        ii+=1
        il(ii)=1
        nprim(ii)=nprim_r(i)
        icent(ii)=icent_r(i)
! the p functions
        do j=1,nprim_r(i)
         coeff(iiprim+j)=pcoeff_r(iprim+j)
         exx  (iiprim+j)=exx_r  (iprim+j)
        end do
        iiprim=iiprim+nprim_r(i)

       else 
        ii+=1
        il(ii)=il_r(i)
        nprim(ii)=nprim_r(i)
        icent(ii)=icent_r(i)
        nshlat(icent_r(i))+=1
        do j=1,nprim_r(i)
         coeff(iiprim+j)=coeff_r(iprim+j)
         exx  (iiprim+j)=exx_r  (iprim+j)
        end do
        iiprim+=nprim_r(i)
       end if
       iprim+=nprim_r(i)
      end do
END_PROVIDER

 BEGIN_PROVIDER [integer, nprimtot ]
BEGIN_DOC
! the size of the completely decontracted basis set
END_DOC
     implicit none
     integer :: i
     nprimtot=0
     do i=1,nshl
      if (il(i).eq.0) then
       nprimtot+=nprim(i)
      else if (il(i).eq.1) then
       nprimtot+=3*nprim(i)
      else if (il(i).eq.2) then
       nprimtot+=6*nprim(i)
      else if (il(i).eq.3) then
       nprimtot+=10*nprim(i)
      end if
     end do
END_PROVIDER

BEGIN_PROVIDER [integer, npst, (nshl) ]
       implicit none
       integer :: nst,ishl 

       nst=1
       do ishl=1,nshl
        npst(ishl)=nst
        nst+=nprim(ishl)
       end do

END_PROVIDER
