! -*- F90 -*-
      SUBROUTINE EXPNND(iorb,ci)
BEGIN_DOC
! expand MOs in primitives
END_DOC
        implicit none
        real*8 :: ci(nbas,nmo)
        integer :: i,iorb
!
        DO I=1,nprimtot
         OWBUF(I)=CI(IWBUF(I),iorb)*coefpr(I)*xnbuf(i)
        END DO
        WRITE(IOUWFN,8806)(OWBUF(I),I=1,nprimtot)
8806    FORMAT(5D16.8)
      END SUBROUTINE EXPNND

BEGIN_PROVIDER [integer, mvals, (0:3)]
     mvals(0)=1
     mvals(1)=3
     mvals(2)=6
     mvals(3)=10
END_PROVIDER
      
 BEGIN_PROVIDER [real*8, owbuf, (nprimtot)]
&BEGIN_PROVIDER [real*8, xnbuf, (nprimtot)]
&BEGIN_PROVIDER [integer, iwbuf, (nprimtot)]
BEGIN_DOC
!  buffer arrays for the expanded MOs
! iwbuf : map of primitives to basis functions
! xnbuf : normalized expansion coefficients of the contractions
! Gaussian convention : p-functions to be multiplied by sqrt(2)
!  d-functions xx, yy, zz to be multiplied by sqrt(4/3)
!  d-functions xy, xz, yz to be multiplied by 2.0
END_DOC
      implicit none
      integer :: iiprim,i,iprim,ibas,ii,l
      real*8 :: gfactor

      iiprim=0
      ibas=0
      do i=1,nshl
       l=il(i)
       do ii=1,mvals(l)
        ibas+=1
        do iprim=1,nprim(i)
         iiprim+=1
         iwbuf(iiprim)=ibas
         xnbuf(iiprim)=gfactor(exxpr(iiprim),l)
         if (l.eq.1) then
          xnbuf(iiprim)*=sqrt(2.D0)
         else if (l.eq.2) then
          if (ii.ge.4) then
           xnbuf(iiprim)*=2.D0
          else
           xnbuf(iiprim)*=sqrt(4.D0/3.D0)
          end if
         end if
        end do
       end do
      end do

      if (writeinfo) then
       do i=1,nprimtot
        write(6,9901) i,exxpr(i),iwbuf(i),xnbuf(i),coefpr(i)
9901    format(i4,F20.12,I4,2F20.12,I4)
       end do
      end if
END_PROVIDER

     real*8 function gfactor(ex,ll)
       implicit none
       real*8 :: ex
       integer :: ll
       real*8 :: dip

       DIP=SQRT((2.D0*EX)**(dble(ll)+1.5D0))
       gfactor=DIP/PI**0.75
     end function gfactor



