! -*- F90 -*-
      program fchkwfn
        call header
        call driver
      end program fchkwfn

      subroutine header 
BEGIN_DOC
! standard header routine, writing just general info 
!
END_DOC
        write(6,*)
        write(6,*) ' Read fchk file ' 
        write(6,*) ' P Reinhardt (Paris, january 2016) ' 
        write(6,*) ' using IRPF90 ' 
        write(6,*)
      end subroutine header

      subroutine driver
BEGIN_DOC
! standard driver routine, triggering the calculation
!
END_DOC
        implicit none
        integer :: i,j

        if (writeinfo) then
         write(6,*) ' read ',nkeylines,' different keylines '
         do i=1,nkeylines
          if (larr(i)) then
           write(6,9901) key(i),ctyp(typ(i)),ndim(i)
          else
           if (typ(i).eq.1) then
            write(6,9902) key(i),nval(i)
           else
            write(6,9903) key(i),rval(i)
           end if
          end if
         end do
9901    format(' array   key = |',A43,'| typ = ',A1,' dimension = ',I12)
9902    format(' integer key = |',A43,'| value = ',I12)
9903    format(' real    key = |',A43,'| value = ',E22.15)
       end if

      j=1
      do i=1,nshl
       call normbf(i,j)
       j+=nprim(i)
      end do

      write(6,*)
      write(6,*) ' normalized basis functions '
      write(6,*)

!integer :: l,m,icarcar
!      do l=0,nlmax
!       do m=1,ncart(l)
!        write(6,*) ' icarcar ',l,m,icarcar(l,m)
!       end do
!      end do

      write(6,*) '       center          l              #prim '
      do i=1,nshl
       write(6,*) icent(i),il(i),nprim(i)
      end do

      call outwfn

      write(6,*)
      write(6,*) ' wrote WFN file '
      write(6,*)
      
      call outort

      write(6,*)
      write(6,*) ' wrote ORTHO files SYSTEM.ORTHO and VECTOR'
      write(6,*)
      
! write the integrals to file
      write(6,*) ' writing file <OVERLAP> '
      write(6,*) ' writing file <DIPOL_X> '
      write(6,*) ' writing file <DIPOL_Y> '
      write(6,*) ' writing file <DIPOL_Z> '
      open(unit=14,file='OVERLAP',form='formatted',status='unknown')
      open(unit=17,file='DIPOL_X',form='formatted',status='unknown')
      open(unit=18,file='DIPOL_Y',form='formatted',status='unknown')
      open(unit=19,file='DIPOL_Z',form='formatted',status='unknown')
      do i=1,nbas
       do j=i,nbas
        if (abs(sao(i,j)) .gt.thresh) write(14,'(2i5,f22.12)') j,i, sao(i,j)
        if (abs(dipx(i,j)).gt.thresh) write(17,'(2i5,f22.12)') j,i,dipx(i,j)
        if (abs(dipy(i,j)).gt.thresh) write(18,'(2i5,f22.12)') j,i,dipy(i,j)
        if (abs(dipz(i,j)).gt.thresh) write(19,'(2i5,f22.12)') j,i,dipz(i,j)
       end do
      end do
      close(14)
      close(17)
      close(18)
      close(19)
      write(6,*)
      write(6,*) ' All done '
      write(6,*)

!     write(6,*)
!     write(6,*) ' testing orthonormality of the orbitals'
!     write(6,*)
!     do i=1,nbas
!      write(6,*) i,smo(i,i),sdiag(i)
!     end do

!     write(6,*) ' off-diagonal elements '
!     do i=2,nbas
!      write(6,*) i,smo(i,i-1)
!     end do
      
    end subroutine driver
     
