! -*- F90 -*-
 BEGIN_PROVIDER [integer, nkeylines]
&BEGIN_PROVIDER [integer, natom ]
&BEGIN_PROVIDER [integer, nalpha]
&BEGIN_PROVIDER [integer, nbeta ]
&BEGIN_PROVIDER [integer, nshl_r]
&BEGIN_PROVIDER [integer, nprimr]
&BEGIN_PROVIDER [integer, lmax  ]
&BEGIN_PROVIDER [integer, nbas  ]
&BEGIN_PROVIDER [integer, nmo   ]
&BEGIN_PROVIDER [logical, sixD  ]
&BEGIN_PROVIDER [logical, tenF  ]
&BEGIN_PROVIDER [real*8, Etot   ]
&BEGIN_PROVIDER [real*8, Virial ]
&BEGIN_PROVIDER [logical, lrhf ]
BEGIN_DOC
! we read from the checkpoint file the necessary data
! 
! a line in a fchk file is 49 characters and a number
! title(1:43), type(44), N=(48:49), integer (I12) or real (E22.15)
! we read at the same time the necessary array dimensions: 
! natom, nbas, nalpha, nbeta, nshl, nprimt, nmo, 6D, 10F
!
! NMO = # independent functions, elimination of MOs
! NBAS = actual basis set, size depends on 6D, 10F or spherical 
END_DOC

      implicit none
      integer :: i,idum,valtyp,n,getval
      real*8 :: rdum,getvalr
      character*49 :: strstr
      character*80 :: line

      nkeylines=0
      open(unit=12,file='FCHK',form='formatted',status='old')
      read(12,*)
      read(12,*)
100   continue
      read(12,'(A80)',end=200) line
!      write(6,*) line
      nkeylines+=1
! read dummy lines for tabulated data
      if (line(48:49).eq.'N=') then
       if (line(44:44).eq.'R') then
        valtyp=2
       else
        valtyp=1
       end if
!       write(6,*) nkeylines,' found table of type ',valtyp
! write the line to a file, reread it for obtaining the integer value in it
       open(unit=13,file='dmdmdm',status='unknown',form='formatted')
       write(13,'(A80)') line
       close(13)
       open(unit=13,file='dmdmdm',status='old',form='formatted')
       read(13,'(A49,I12)') strstr,n
       close(13)
!       write(6,*) ' dimension ',n
       if (valtyp.eq.1) then
        read(12,*) (idum,i=1,n)
       else
        read(12,*) (rdum,i=1,n)
       end if
      else
! no tabular data, but important numbers
       if (line(1:15).eq.'Number of atoms') then
        natom=getval(line)
         write(6,*) ' Natom  = ',natom
       else if (line(1:25).eq.'Number of alpha electrons') then
        nalpha=getval(line)
         write(6,*) ' Nalpha = ',nalpha
       else if (line(1:24).eq.'Number of beta electrons') then
        nbeta=getval(line)
         write(6,*) ' Nbeta  = ',nbeta
        if (nalpha.eq.nbeta) lrhf=.true.
       else if (line(1:25).eq.'Number of basis functions') then
        nbas=getval(line)
         write(6,*) ' Nbas   = ',nbas
       else if (line(1:31).eq.'Number of independant functions') then
        nmo=getval(line)
         write(6,*) ' NMO    = ',nmo
       else if (line(1:31).eq.'Number of independent functions') then
        nmo=getval(line)
         write(6,*) ' NMO    = ',nmo
       else if (line(1:27).eq.'Number of contracted shells') then
        nshl_r=getval(line)
         write(6,*) ' Nshl_r = ',nshl_r
       else if (line(1:25).eq.'Highest angular momentum') then
        lmax=getval(line)
         write(6,*) ' Lmax   = ',Lmax
        lmax+=1
         write(6,*) ' Lmax+1 = ',Lmax
       else if (line(1:26).eq.'Number of primitive shells') then
        nprimr=getval(line)
         write(6,*) ' Nprimr = ',nprimr,' (read # primitives) '
       else if (line(1:24).eq.'Pure/Cartesian d shells') then
        sixD=getval(line).eq.1
         write(6,*) ' 6 D    = ',sixD
        if (.not.sixD) then
         write(6,*) ' transformation spherical -> cartesian not' &
              ,' yet implemented '
         stop ' work harder '
        end if
       else if (line(1:24).eq.'Pure/Cartesian f shells') then
        tenF=getval(line).eq.1
         write(6,*) ' 10 F   = ',tenF
        if (.not.tenF) then
         write(6,*) ' transformation spherical -> cartesian not ' & 
              ,'yet implemented '
         stop ' work harder '
        end if
       else if (line(1:10).eq.'SCF Energy') then
        Etot=getvalr(line)
         write(6,*) ' Etot   = ',Etot
       else if (line(1:12).eq.'Virial Ratio') then
        Virial=getvalr(line)
         write(6,*) ' Virial = ',Virial
       end if
      end if
      go to 100
200   continue
      close (12)
      
      write(6,*)
!     write(6,*) ' NKEYLINES = ',nkeylines
       
END_PROVIDER

 BEGIN_PROVIDER [integer, typ, (nkeylines) ]
&BEGIN_PROVIDER [logical, larr, (nkeylines) ]
&BEGIN_PROVIDER [integer, nval, (nkeylines) ]
&BEGIN_PROVIDER [integer, ndim, (nkeylines) ]
&BEGIN_PROVIDER [real*8, rval, (nkeylines) ]
&BEGIN_PROVIDER [character*43, key, (nkeylines) ]
&BEGIN_PROVIDER [real*8, pos, (3,natom)]
&BEGIN_PROVIDER [integer, nz, (natom)]
&BEGIN_PROVIDER [real*8, exx_r,    (nprimr)]
&BEGIN_PROVIDER [real*8, coeff_r,  (nprimr)]
&BEGIN_PROVIDER [real*8, pcoeff_r, (nprimr)]
&BEGIN_PROVIDER [integer, nprim_r, (nshl_r)]
&BEGIN_PROVIDER [integer, il_r, (nshl_r)]
&BEGIN_PROVIDER [integer, icent_r, (nshl_r)]
&BEGIN_PROVIDER [integer, nsh, (natom)]
&BEGIN_PROVIDER [real*8, ORBENalpha, (NMO) ]
&BEGIN_PROVIDER [real*8, ORBENbeta, (NMO) ]
&BEGIN_PROVIDER [real*8, CIalpha, (NBAS,NBAS) ]
&BEGIN_PROVIDER [real*8, CIbeta,  (NBAS,NBAS) ]
!&BEGIN_PROVIDER [real*8, CIalpha, (NBAS,NMO) ]
!&BEGIN_PROVIDER [real*8, CIbeta,  (NBAS,NMO) ]
BEGIN_DOC
! we give the full dimension for CIalpha and CIbeta
! for the ORTHO vector files we have to complete these
! to a full set of orbitals (Schmidt procedure)
END_DOC

      implicit none
      integer :: i,idum,j,k
      real*8 :: rdum
      character*80 :: line
      character*49 :: strstr

      do i=1,nkeylines
       larr(i)=.false.
       nval(i)=0
       rval(i)=0
       ndim(i)=0
       key(i)='                                          '
      end do

      do i=1,nbas
       do j=1,nbas
        cialpha(i,j)=0.D0
        cibeta(i,j)=0.D0
       end do
      end do

      open(unit=12,file='FCHK',form='formatted',status='old')
      read(12,*)
      read(12,*)
      i=0
100   continue
      read(12,'(A80)',end=200) line
      if (writeinfo) write(6,*) line
      i+=1
      if (line(44:44).eq.'R') then
       typ(i)=2
      else
       typ(i)=1
      end if
      key(i)=line(1:43)
      if (writeinfo) write(6,*) ' key |',key(i),'| '
! write the line to a file, reread it for obtaining the integer value in it
      open(unit=13,file='dmdmdm',status='unknown',form='formatted')
      write(13,'(A80)') line
      close(13)
      open(unit=13,file='dmdmdm',status='old',form='formatted')
! read dummy lines for tabulated data
      if (line(48:49).eq.'N=') then
!      write(6,*) ' reading dummy lines for a ',ctyp(typ(i)),' array'
       larr(i)=.true.
       read(13,'(A49,I12)') strstr,ndim(i)
!       write(6,*) ' i, ndim (i) ',i,ndim(i)
       if (typ(i).eq.1) then
        if (line(1:14).eq.'Atomic numbers') then
         read(12,*) (nz(j),j=1,natom)
        else if (line(1:11).eq.'Shell types') then
         read(12,*) (il_r(j),j=1,nshl_r)
integer :: nnbas
         nnbas=0
         do j=1,nshl_r
          if (il_r(j).eq.0) then
           nnbas+=1
          else if (il_r(j).eq.1) then
           nnbas+=3
          else if (il_r(j).eq.-1) then
           nnbas+=4
          else if (il_r(j).eq.2) then
           if (sixD) then
            nnbas+=6
           else
            nnbas+=5
           end if
          else if (il_r(j).eq.3) then
           if (tenF) then
            nnbas+=10
           else
            nnbas+=7
           end if
          else
           stop ' L has to be smaller than 4, work harder ' 
          end if
         end do
         write(6,*) ' found ',nnbas,' basis functions '
         if (nnbas.ne.nbas) stop ' incoherence nbas and nnbas '

        else if (line(1:30).eq.'Number of primitives per shell') then
         read(12,*) (nprim_r(j),j=1,nshl_r)
        else if (line(1:17).eq.'Shell to atom map') then
         read(12,*) (icent_r(j),j=1,nshl_r)
        else
         read(12,*) (idum,j=1,ndim(i))
        end if
       else
        if (line(1:29).eq.'Current cartesian coordinates') then
         read(12,*) ((pos(j,k),j=1,3),k=1,natom)
        else if (line(1:19).eq.'Primitive exponents') then
         read(12,*) (exx_r(j),j=1,nprimr)
        else if (line(1:24).eq.'Contraction coefficients') then
         read(12,*) (coeff_r(j),j=1,nprimr)
        else if (line(1:31).eq.'P(S=P) Contraction coefficients') then
         read(12,*) (pcoeff_r(j),j=1,nprimr)
        else if (line(1:22).eq.'Alpha Orbital Energies') then
         read(12,*) (orbenalpha(j),j=1,nmo)
         do j=1,nmo
          orbenbeta(j)=orbenalpha(j)
         end do
        else if (line(1:21).eq.'Beta Orbital Energies') then
         read(12,*) (orbenbeta(j),j=1,nmo)
        else if (line(1:21).eq.'Alpha MO coefficients') then
         read(12,*) ((CIalpha(j,k),j=1,nbas),k=1,nmo)
         do j=1,nbas
          do k=1,nmo
           CIbeta(j,k)=CIalpha(j,k)
          end do
         end do
        else if (line(1:20).eq.'Beta MO coefficients') then
         read(12,*) ((CIbeta(j,k),j=1,nbas),k=1,nmo)
        else
         read(12,*) (rdum,j=1,ndim(i))
        end if
       end if
      else
       if (typ(i).eq.1) then
!        write(6,*) ' reading integer value, i= ',i
        read(13,'(A49,I12)') strstr,nval(i)
       else
!        write(6,*) ' reading real value, i= ',i
        read(13,'(A49,E22.15)') strstr,rval(i)
       end if
      end if
      close(13,status='delete')
      go to 100
200   continue
      close(12)
END_PROVIDER

BEGIN_PROVIDER [character*1, ctyp, (2) ]
    ctyp(1)='I'
    ctyp(2)='R'
END_PROVIDER

      integer function getval(line)
BEGIN_DOC
! extract from a text line the integer value
END_DOC
        implicit none
        character*80 :: line
        character*49 :: strstr
! write the line to a file, reread it for obtaining the integer value in it
        open(unit=13,file='dmdmdm',status='unknown',form='formatted')
        write(13,'(A80)') line
        close(13)
        open(unit=13,file='dmdmdm',status='old',form='formatted')
        read(13,'(A49,I12)') strstr,getval
        close(13,status='delete')
      end function getval

      real function getvalr(line)
BEGIN_DOC
! extract from a text line the real value
END_DOC
        implicit none
        character*80 :: line
        character*49 :: strstr
! write the line to a file, reread it for obtaining the integer value in it
        open(unit=13,file='dmdmdm',status='unknown',form='formatted')
        write(13,'(A80)') line
        close(13)
        open(unit=13,file='dmdmdm',status='old',form='formatted')
        read(13,'(A49,E22.15)') strstr,getvalr
        close(13,status='delete')
      end function getvalr

