! -*- F90 -*-
BEGIN_PROVIDER [integer, iouort]
      iouort=58
END_PROVIDER

BEGIN_PROVIDER [integer, lmaxat, (natom)]
         implicit none
         integer :: i
         do i=1,nshl
          lmaxat(icent(i))=max(lmaxat(icent(i)),il(i))
         end do
END_PROVIDER 


      SUBROUTINE OUTORT
BEGIN_DOC
!
! we create our ORTHO files
!
END_DOC
        implicit none
        integer :: iat,i,j

        WRITE(6,*)
        WRITE(6,*) '-------------------------------------------------'
        WRITE(6,*) '--- O R T H O ----------- O R T H O -------------'
        WRITE(6,*) '-------------------------------------------------'
!
        IOUort=58
        OPEN(UNIT=IOUort,FILE='SYSTEM.ORTHO',FORM='FORMATTED',STATUS='UNKNOWN')
        CLOSE(IOUort,STATUS='DELETE')
        OPEN(UNIT=IOUort,FILE='SYSTEM.ORTHO',FORM='FORMATTED',STATUS='NEW')
        
!        WRITE(IOUort,*) ' The SYSTEM.ORTHO file from a FCHK file'
!
        WRITE(IOUort,'(I4)') NATOM

integer :: ishl,iishl,iprim,iiprim

        iishl=0
        iiprim=0
        DO IAT=1,NATOM
         WRITE(IOUort,'(2I6,3F20.12)') nz(iat),nshlat(iat),(pos(j,iat),j=1,3)
         do ishl=1,nshlat(iat)
          iishl+=1
          WRITE(IOUort,'(2I8)') il(iishl),nprim(iishl)
          do iprim=1,nprim(iishl)
           iiprim+=1
           write(iouort,'(2F20.12)') exx(iiprim),coeff(iiprim)
          end do
         end do 
        end do 
        close(iouwfn)

 integer :: itwo,izero,ialpha
        itwo=2
        izero=0
        if (nalpha.eq.nbeta) then
! we have a closed-shell case
         open(unit=iouort,file='VECTOR.FCHK',form='formatted',status='unknown')
         write(6,*) ' ... writing file VECTOR.FCHK '
         do i=1,nbas
          call filldmp(cialpha(1,i)) 
          write(iouort,'(4E20.12)') (cidmp(ialpha),ialpha=1,nbas)
         end do
         write(iouort,'(40I2)') (itwo,i=1,nalpha),(izero,j=1,nbas-nalpha)
         write(iouort,'(40I2)') (itwo,i=1,nbas)
         close(iouort)
        else
! we have a open-shell case, probably UHF
         open(unit=iouort,file='VECTOR.ALPHA.FCHK',form='formatted' &
              ,status='unknown')
         write(6,*) ' ... writing file VECTOR.ALPHA.FCHK '
         do i=1,nbas
          call filldmp(cialpha(1,i)) 
          write(iouort,'(4E20.12)') (cidmp(ialpha),ialpha=1,nbas)
         end do
         write(iouort,'(40I2)') (itwo,i=1,nalpha),(izero,j=1,nbas-nalpha)
         write(iouort,'(40I2)') (itwo,i=1,nbas)
         close(iouort)

         open(unit=iouort,file='VECTOR.BETA.FCHK',form='formatted' &
              ,status='unknown')
         write(6,*) ' ... writing file VECTOR.BETA.FCHK '
         do i=1,nbas
          call filldmp(cibeta(1,i)) 
          write(iouort,'(4E20.12)') (cidmp(ialpha),ialpha=1,nbas)
         end do
         write(iouort,'(40I2)') (itwo,i=1,nbeta),(izero,j=1,nbas-nbeta)
         write(iouort,'(40I2)') (itwo,i=1,nbas)
         close(iouort)
        end if

      end subroutine outort

BEGIN_PROVIDER [real*8, cidmp, (nbas) ]
BEGIN_DOC
! a temporary array for storing one orbital
END_DOC
END_PROVIDER

      subroutine filldmp(civec)
        implicit none
        real*8 :: civec(nbas)
        integer :: i,indx,j
       
        indx=1
        do i=1,nshl
!        write(6,*) 'i= ',i
! reordering for d functions, we have 6
         if (il(i).eq.2) then
           cidmp(indx  )=civec(indx)
           cidmp(indx+1)=civec(indx+3)
           cidmp(indx+2)=civec(indx+4)
           cidmp(indx+3)=civec(indx+1)
           cidmp(indx+4)=civec(indx+5)
           cidmp(indx+5)=civec(indx+2)
           indx=indx+6
         else
          do j=1,ncart(il(i))
           cidmp(indx)=civec(indx)
           indx=indx+1
          end do
         end if
        end do
!       do i=1,nbas
!        write(6,*) ' i, in, out ',i,civec(i),cidmp(i)
!       end do
      end subroutine filldmp
      
