! -*- F90 -*-
BEGIN_PROVIDER [integer, iouwfn]
      outwfn=58
END_PROVIDER

      SUBROUTINE OUTWFN
!
! we try to create a Gaussian WFN file
!
        implicit none
        integer :: iat,i,j

        WRITE(6,*)
        WRITE(6,*) '-------------------------------------------------'
        WRITE(6,*) '--- W F N ----------- W F N ---------------------'
        WRITE(6,*) '-------------------------------------------------'
!
        IOUWFN=58
        OPEN(UNIT=IOUWFN,FILE='WFN',FORM='FORMATTED',STATUS='UNKNOWN')
        CLOSE(IOUWFN,STATUS='DELETE')
        OPEN(UNIT=IOUWFN,FILE='WFN',FORM='FORMATTED',STATUS='NEW')
        
        WRITE(IOUWFN,*) 'WFN file from a FCHK file'
!
        if (lrhf) then
         WRITE(IOUWFN,8801) Nalpha,NPRIMTot,NATOM
        else 
         WRITE(IOUWFN,8801) Nalpha+Nbeta,NPRIMTot,NATOM
        end if
8801    FORMAT('GAUSSIAN',I15,' MOL ORBITALS',I7,' PRIMITIVES',I9 &
             ,' NUCLEI') 
        DO IAT=1,NATOM
         WRITE(IOUWFN,8802) SYMBAT(NZ(IAT)),IAT,IAT,(POS(J,IAT),J=1,3) &
              ,NZ(IAT)
8802     FORMAT(1X,A2,I5,'    (CENTRE',I3,')',F13.8,F12.8,F12.8 &
              ,'  CHARGE =',I3,'.0')
        END DO

integer:: iprim,iiprim,ii

        iprim=0
        iiprim=0
        do i=1,nshl
! s functions
         if (il(i).eq.0) then
          do ii=1,nprim(i)
           iiprim+=1
           exxpr(iiprim)=exx(iprim+ii)
           coefpr(iiprim)=coeff(iprim+ii)
           icepr(iiprim)=icent(i)
           itypr(iiprim)=1
          end do
! p functions
         else if (il(i).eq.1) then
          do ii=1,nprim(i)
           iiprim+=1
           exxpr(iiprim)=exx(iprim+ii)
           coefpr(iiprim)=coeff(iprim+ii)
           icepr(iiprim)=icent(i)
           itypr(iiprim)=2
          end do
          do ii=1,nprim(i)
           iiprim+=1
           exxpr(iiprim)=exx(iprim+ii)
           coefpr(iiprim)=coeff(iprim+ii)
           icepr(iiprim)=icent(i)
           itypr(iiprim)=3
          end do
          do ii=1,nprim(i)
           iiprim+=1
           exxpr(iiprim)=exx(iprim+ii)
           coefpr(iiprim)=coeff(iprim+ii)
           icepr(iiprim)=icent(i)
           itypr(iiprim)=4
          end do
! d functions
         else if (il(i).eq.2) then
          do ii=1,nprim(i)
           iiprim+=1
           exxpr(iiprim)=exx(iprim+ii)
           coefpr(iiprim)=coeff(iprim+ii)
           icepr(iiprim)=icent(i)
           itypr(iiprim)=5
          end do
          do ii=1,nprim(i)
           iiprim+=1
           exxpr(iiprim)=exx(iprim+ii)
           coefpr(iiprim)=coeff(iprim+ii)
           icepr(iiprim)=icent(i)
           itypr(iiprim)=6
          end do
          do ii=1,nprim(i)
           iiprim+=1
           exxpr(iiprim)=exx(iprim+ii)
           coefpr(iiprim)=coeff(iprim+ii)
           icepr(iiprim)=icent(i)
           itypr(iiprim)=7
          end do
          do ii=1,nprim(i)
           iiprim+=1
           exxpr(iiprim)=exx(iprim+ii)
           coefpr(iiprim)=coeff(iprim+ii)
           icepr(iiprim)=icent(i)
           itypr(iiprim)=8
          end do
          do ii=1,nprim(i)
           iiprim+=1
           exxpr(iiprim)=exx(iprim+ii)
           coefpr(iiprim)=coeff(iprim+ii)
           icepr(iiprim)=icent(i)
           itypr(iiprim)=9
          end do
          do ii=1,nprim(i)
           iiprim+=1
           exxpr(iiprim)=exx(iprim+ii)
           coefpr(iiprim)=coeff(iprim+ii)
           icepr(iiprim)=icent(i)
           itypr(iiprim)=10
          end do
         else
          stop ' no f functions yet ... '
         end if
         iprim=iprim+nprim(i)
        end do
        
        WRITE(IOUWFN,8804) (ICEPR(IPRIM),IPRIM=1,NPRIMTot)
        WRITE(IOUWFN,8814) (ITYPR(IPRIM),IPRIM=1,NPRIMTot)
        WRITE(IOUWFN,8803) (EXXPR(IPRIM),IPRIM=1,NPRIMTot)
8804    FORMAT('CENTRE ASSIGNMENTS  ',20I3)
8814    FORMAT('TYPE ASSIGNMENTS    ',20I3)
8803    FORMAT('EXPONENTS ',5D14.7)

integer :: iorb
        do iorb=1,nalpha
         if (lrhf) then
          WRITE(IOUWFN,8855) IORB,ORBENalpha(IORB)
! for the molecular orbitals we have to multiply the expansion coefficients 
! with the contraction coefficients, as the atomic orbitals are already 
! normalized
          call expnnd(iorb,cialpha)
         else
          WRITE(IOUWFN,8805) IORB,ORBENalpha(IORB)
          call expnnd(iorb,cialpha)
!!$       WRITE(IOUWFN,8806) (OWBUF(IPRIM),IPRIM=1,IPCOUNT)
!!$ 8806  FORMAT(5E16.8)
         end if
        end do
        if (.not.lrhf) then
         do iorb=1,nbeta
          WRITE(IOUWFN,8805) IORB+nmo,ORBENbeta(IORB)
          call expnnd(iorb,cibeta)
         end do
        end if
8805    FORMAT('MO',I5 &
             ,'     MO 0.0        OCC NO =    1.0000000  ORB. ENERGY =', &
             F12.7)
8855    FORMAT('MO',I5 &
             ,'     MO 0.0        OCC NO =    2.0000000  ORB. ENERGY =', &
             F12.7)
      WRITE(IOUWFN,8807) ETOT,virial
 8807 FORMAT('END DATA',/,' THE  HF ENERGY =',F20.12 &
           ,' THE VIRIAL(-V/T)=',F13.8) 
      CLOSE(IOUWFN)
      
    end SUBROUTINE OUTWFN

 BEGIN_PROVIDER [real*8, exxpr, (nprimtot) ]
&BEGIN_PROVIDER [real*8, coefpr, (nprimtot) ]
&BEGIN_PROVIDER [integer, icepr, (nprimtot) ]
&BEGIN_PROVIDER [integer, itypr, (nprimtot) ]
END_PROVIDER

