(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 10.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[      9793,        327]
NotebookOptionsPosition[      8632,        282]
NotebookOutlinePosition[      8971,        297]
CellTagsIndexPosition[      8928,        294]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["\<\
Verification of the norm of a simple STO - 3 G basis function for H\
\>", "Title",
 CellChangeTimes->{{3.662981374888363*^9, 3.662981409096541*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"f1", "[", "r_", "]"}], ":=", 
  RowBox[{"Exp", "[", 
   RowBox[{
    RowBox[{"-", "3.42525091"}], 
    RowBox[{"r", "^", "2"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"f2", "[", "r_", "]"}], ":=", 
  RowBox[{"Exp", "[", 
   RowBox[{
    RowBox[{"-", "0.62391373"}], 
    RowBox[{"r", "^", "2"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"f3", "[", "r_", "]"}], ":=", 
  RowBox[{"Exp", "[", 
   RowBox[{
    RowBox[{"-", "0.16885540"}], 
    RowBox[{"r", "^", "2"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"c1", "=", "0.15432897"}], "\[IndentingNewLine]", 
 RowBox[{"c2", "=", "0.53532814"}], "\[IndentingNewLine]", 
 RowBox[{"c3", "=", "0.44463454"}]}], "Input",
 CellChangeTimes->{{3.662980624168232*^9, 3.662980732608051*^9}, {
  3.662980888676958*^9, 3.662980905866007*^9}, {3.66298096746612*^9, 
  3.662981046718215*^9}}],

Cell[BoxData["0.15432897`"], "Output",
 CellChangeTimes->{3.662981100118661*^9}],

Cell[BoxData["0.53532814`"], "Output",
 CellChangeTimes->{3.662981100119912*^9}],

Cell[BoxData["0.44463454`"], "Output",
 CellChangeTimes->{3.66298110012144*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"N1", "=", 
  RowBox[{"1", "/", 
   RowBox[{"Sqrt", "[", 
    RowBox[{"Integrate", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"f1", "[", "r", "]"}], "r"}], ")"}], "^", "2"}], ",", 
      RowBox[{"{", 
       RowBox[{"r", ",", "0", ",", "\[Infinity]"}], "}"}]}], "]"}], 
    "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{"N2", "=", 
  RowBox[{"1", "/", 
   RowBox[{"Sqrt", "[", 
    RowBox[{"Integrate", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"f2", "[", "r", "]"}], "r"}], ")"}], "^", "2"}], ",", 
      RowBox[{"{", 
       RowBox[{"r", ",", "0", ",", "\[Infinity]"}], "}"}]}], "]"}], 
    "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{"N3", "=", 
  RowBox[{"1", "/", 
   RowBox[{"Sqrt", "[", 
    RowBox[{"Integrate", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"f3", "[", "r", "]"}], "r"}], ")"}], "^", "2"}], ",", 
      RowBox[{"{", 
       RowBox[{"r", ",", "0", ",", "\[Infinity]"}], "}"}]}], "]"}], 
    "]"}]}]}]}], "Input",
 CellChangeTimes->{{3.662980743817677*^9, 3.662980776114098*^9}, {
  3.662980824590643*^9, 3.662980827185755*^9}, {3.662981050876095*^9, 
  3.662981106948768*^9}}],

Cell[BoxData["6.36113067148303`"], "Output",
 CellChangeTimes->{{3.662980777932827*^9, 3.662980786155967*^9}, {
   3.662980829796816*^9, 3.66298083524373*^9}, 3.662980912316808*^9, {
   3.662981102303036*^9, 3.662981108185242*^9}}],

Cell[BoxData["1.7736112360856897`"], "Output",
 CellChangeTimes->{{3.662980777932827*^9, 3.662980786155967*^9}, {
   3.662980829796816*^9, 3.66298083524373*^9}, 3.662980912316808*^9, {
   3.662981102303036*^9, 3.662981108229221*^9}}],

Cell[BoxData["0.6655048727784046`"], "Output",
 CellChangeTimes->{{3.662980777932827*^9, 3.662980786155967*^9}, {
   3.662980829796816*^9, 3.66298083524373*^9}, 3.662980912316808*^9, {
   3.662981102303036*^9, 3.662981108282751*^9}}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"f", "[", "r_", "]"}], ":=", 
  RowBox[{
   RowBox[{"c1", " ", "N1", " ", 
    RowBox[{"f1", "[", "r", "]"}]}], "+", 
   RowBox[{"c2", " ", "N2", " ", 
    RowBox[{"f2", "[", "r", "]"}]}], "+", 
   RowBox[{"c3", " ", "N3", " ", 
    RowBox[{"f3", "[", "r", "]"}]}]}]}]], "Input",
 CellChangeTimes->{{3.662980813965442*^9, 3.662980871204263*^9}, {
  3.662980929658276*^9, 3.662980962659108*^9}, {3.662981123667802*^9, 
  3.662981169850617*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Integrate", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"f", "[", "r", "]"}], "r"}], ")"}], "^", "2"}], ",", 
   RowBox[{"{", 
    RowBox[{"r", ",", "0", ",", "\[Infinity]"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.662981182330626*^9, 3.662981186866276*^9}}],

Cell[BoxData["0.9999999908898001`"], "Output",
 CellChangeTimes->{3.662981188411716*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Normalizing Gaussians ...", "Section",
 CellChangeTimes->{{3.662982739048665*^9, 3.662982768170107*^9}, {
  3.662984587324067*^9, 3.6629845956707*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"l", "=", "2"}]], "Input",
 CellChangeTimes->{{3.66298493082074*^9, 3.662984931430726*^9}, {
  3.662984974454503*^9, 3.662984974717023*^9}}],

Cell[BoxData["2"], "Output",
 CellChangeTimes->{3.662984932018882*^9, 3.662984975175387*^9}]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Nf", "[", 
   RowBox[{"a_", ",", "l_"}], "]"}], ":=", 
  RowBox[{"Sqrt", "[", 
   RowBox[{
    RowBox[{"Sqrt", "[", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"2", " ", 
        RowBox[{"a", "/", "\[Pi]"}]}], ")"}], "^", "3"}], "]"}], 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"4", "a"}], ")"}], "^", "l"}], "/", 
     RowBox[{"Factorial2", "[", 
      RowBox[{
       RowBox[{"2", "l"}], "-", "1"}], "]"}]}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Gf", "[", 
   RowBox[{"x_", ",", "y_", ",", "z_", ",", "l_", ",", "a_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"Nf", "[", 
    RowBox[{"a", ",", "l"}], "]"}], 
   RowBox[{"x", "^", "l"}], " ", 
   RowBox[{"Exp", "[", 
    RowBox[{
     RowBox[{"-", "a"}], 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"x", "^", "2"}], "+", 
       RowBox[{"y", "^", "2"}], "+", 
       RowBox[{"z", "^", "2"}]}], ")"}]}], "]"}], " "}]}]}], "Input",
 CellChangeTimes->{{3.662982846462824*^9, 3.662982852527206*^9}, {
  3.66298459901659*^9, 3.66298468842889*^9}, {3.662984723252457*^9, 
  3.662984832699055*^9}, {3.662984954575893*^9, 3.662984954988363*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Integrate", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Gf", "[", 
      RowBox[{"x", ",", "y", ",", "z", ",", "l", ",", "a"}], "]"}], "^", 
     "2"}], ",", 
    RowBox[{"{", 
     RowBox[{"x", ",", 
      RowBox[{"-", "\[Infinity]"}], ",", "\[Infinity]"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"y", ",", 
      RowBox[{"-", "\[Infinity]"}], ",", "\[Infinity]"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"z", ",", 
      RowBox[{"-", "\[Infinity]"}], ",", "\[Infinity]"}], "}"}]}], "]"}], "//",
   "Simplify"}]], "Input",
 CellChangeTimes->{{3.662984837610613*^9, 3.662984911595222*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Integrate", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Gf", "[", 
      RowBox[{"x", ",", "y", ",", "z", ",", "l", ",", "a1"}], "]"}], 
     RowBox[{"Gf", "[", 
      RowBox[{"x", ",", "y", ",", "z", ",", "l", ",", "a2"}], "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"x", ",", 
      RowBox[{"-", "\[Infinity]"}], ",", "\[Infinity]"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"y", ",", 
      RowBox[{"-", "\[Infinity]"}], ",", "\[Infinity]"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"z", ",", 
      RowBox[{"-", "\[Infinity]"}], ",", "\[Infinity]"}], "}"}]}], "]"}], "//",
   "Simplify"}]], "Input",
 CellChangeTimes->{{3.662985005957248*^9, 3.662985036119955*^9}}],

Cell[BoxData[
 RowBox[{"ConditionalExpression", "[", 
  RowBox[{
   FractionBox[
    RowBox[{"8", " ", 
     SqrtBox["2"], " ", 
     SqrtBox[
      RowBox[{
       SuperscriptBox["a1", "2"], " ", 
       SqrtBox[
        SuperscriptBox["a1", "3"]]}]], " ", 
     SqrtBox[
      RowBox[{
       SuperscriptBox["a2", "2"], " ", 
       SqrtBox[
        SuperscriptBox["a2", "3"]]}]]}], 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"a1", "+", "a2"}], ")"}], 
     RowBox[{"7", "/", "2"}]]], ",", 
   RowBox[{
    RowBox[{"Re", "[", 
     RowBox[{"a1", "+", "a2"}], "]"}], ">", "0"}]}], "]"}]], "Output",
 CellChangeTimes->{{3.662984881189057*^9, 3.662984982502444*^9}, 
   3.662985044932656*^9}]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
WindowSize->{808, 716},
WindowMargins->{{295, Automatic}, {Automatic, -10}},
FrontEndVersion->"10.0 for Linux x86 (32-bit) (December 4, 2014)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[580, 22, 158, 3, 150, "Title"],
Cell[CellGroupData[{
Cell[763, 29, 896, 24, 143, "Input"],
Cell[1662, 55, 80, 1, 32, "Output"],
Cell[1745, 58, 80, 1, 32, "Output"],
Cell[1828, 61, 79, 1, 32, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1944, 67, 1260, 39, 77, "Input"],
Cell[3207, 108, 231, 3, 32, "Output"],
Cell[3441, 113, 233, 3, 32, "Output"],
Cell[3677, 118, 233, 3, 32, "Output"]
}, Open  ]],
Cell[3925, 124, 477, 12, 32, "Input"],
Cell[CellGroupData[{
Cell[4427, 140, 322, 9, 32, "Input"],
Cell[4752, 151, 88, 1, 32, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4877, 157, 157, 2, 65, "Section"],
Cell[CellGroupData[{
Cell[5059, 163, 163, 3, 32, "Input"],
Cell[5225, 168, 92, 1, 32, "Output"]
}, Open  ]],
Cell[5332, 172, 1177, 36, 55, "Input"],
Cell[6512, 210, 635, 18, 55, "Input"],
Cell[CellGroupData[{
Cell[7172, 232, 715, 19, 55, "Input"],
Cell[7890, 253, 702, 24, 115, "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
